// $Id: MailProcRemote.java,v 1.9 2004/03/21 21:45:38 cfry Exp $

package com.spamnbeans.server;

import com.spamnbeans.msg.MsgStats;

/**
 * Provide the external interface to the MailProc SessionBean.
 * 
 * <p>
 * The MailProc Bean gets requests from clients, interacts with ServerStat,
 * ClientStat, and MsgStat EntityBeans, and processes messages using SpamC
 * SessionBeans.
 * 
 * @author Andrew Boyer, <a href="mailto:aboyer@andrew.cmu.edu">
 *         aboyer@andrew.cmu.edu</a>
 * @version 1.1
 */
public interface MailProcRemote extends javax.ejb.EJBObject {
	/**
	 * Specify the currently connected Server
	 */
	public void attachServer(String name) throws java.rmi.RemoteException;

	/**
	 * Return the ServerID of the currently connected Server
	 */
	public Integer getServerID() throws java.rmi.RemoteException;

	/**
	 * Return the Name of the currently connected Server
	 */
	public String getServerName() throws java.rmi.RemoteException;

	/**
	 * Process a single e-mail message
	 * 
	 * @param clientID
	 *            The ClientID of the requesting Client
	 * @param msgID
	 *            The MessageID of the requesting Client
	 * @param message
	 *            The full text of the e-mail to check
	 * @return The extra e-mail headers generated
	 */
	public MsgStats processMessage(
		Integer clientID,
		Integer msgID,
		String message)
		throws
			java.rmi.RemoteException,
			com.spamnbeans.server.InvalidClientException,
			com.spamnbeans.server.ProcessingFailureException;
}
