package com.spamnbeans.util;

import java.util.logging.*;
import java.io.*;
import java.text.*;
import java.util.Date;

/**
 * Format logging messages they way we want them. Adapted from SimpleFormatter.
 */
public class SpamFormatter extends Formatter {

	Date dat = new Date();
	// private final static String format = "{0,date} {0,time}";
	private final static String format = "{0,time}";
	private MessageFormat formatter;

	private Object args[] = new Object[1];

	// Line separator string.  This is the value of the line.separator
	// property at the moment that the SimpleFormatter was created.
	private String lineSeparator = (String) java.security.AccessController.doPrivileged(
			   new sun.security.action.GetPropertyAction("line.separator"));

	/**
	 * Format the given LogRecord.
	 * @param record the log record to be formatted.
	 * @return a formatted log record
	 */
	public synchronized String format(LogRecord record) {
		LogManager manager = LogManager.getLogManager();
		String v = manager.getProperty(SpamFormatter.class.getName() +".verbose");
		boolean verbose = (v == null || v.equals("true"));
		StringBuffer sb = new StringBuffer();
		if (verbose) {
			// Minimize memory allocations here.
			dat.setTime(record.getMillis());
			args[0] = dat;
			StringBuffer text = new StringBuffer();
			if (formatter == null) {
				formatter = new MessageFormat(format);
			}
			formatter.format(args, text, null);
			sb.append(text);
			sb.append(" ");
			sb.append(record.getLevel().getLocalizedName());
			sb.append(" ");
			String name = record.getSourceClassName() ;
			if (name == null) {
				name = record.getLoggerName();
			}
			int lastDot = name.lastIndexOf(".");
			if (lastDot >= 0) {
				name = name.substring(lastDot+1);
			}
			sb.append(name);
			if (record.getSourceMethodName() != null) {
				sb.append(".");
				sb.append(record.getSourceMethodName());
			}
			sb.append(lineSeparator);
		}
		String message = formatMessage(record);
		sb.append(message);
		sb.append(lineSeparator);
		if (verbose && record.getThrown() != null) {
			try {
				StringWriter sw = new StringWriter();
				PrintWriter pw = new PrintWriter(sw);
				record.getThrown().printStackTrace(pw);
				pw.close();
				sb.append(sw.toString());
			} catch (Exception ex) {
			}
		}
		return sb.toString();
	}
}
